Video Tutorial
Watch this video to know how to integrate Razorpay Hosted Checkout on your website. Follow these steps to integrate the Hosted Checkout form on your website:1
Step 1
Build Integration: Use the sample codes to integrate the Razorpay Hosted Integration on your website.
2
Step 2
Test Integration: Make a test payment using the payment methods configured at checkout to ensure the integration is working as expected.
3
Step 3
Go-live Checklist: Check the go-live checklist before taking the integration live.
1. Build Integration
Follow the steps given below:1.1 Create an Order in Server
Order is an important step in the payment process.- An order should be created for every payment.
- You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
- The
order_idreceived in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
Handy TipsUnder the Authorization section in Postman, select Basic Auth and add the Key Id and secret as the Username and Password, respectively.You can create an order manually by integrating the API sample codes on your server.Request Parameters
amount mandatory
: integer The transaction amount, expressed in the currency subunit. For example, for an actual amount of , the value of this field should be 22225.currency mandatory
: string The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters.receipt optional
: string Your receipt id for this order should be passed here. Maximum length is 40 characters.notes optional
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.partial_payment optional
: boolean Indicates whether the customer can make a partial payment. Possible values:true: The customer can make partial payments.false(default): The customer cannot make partial payments.
first_payment_min_amount optional
: integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.Response Parameters
Descriptions for the response parameters are present in the Orders Entity parameters table.Error Response Parameters
The error response parameters are available in the API Reference Guide.1.2 Pass Payment Options to Hosted Checkout
Add the Pay button on your web page using the checkout code given below. The hosted checkout page is displayed when the customers click the Pay button. 1.2.1 Code to Add Pay Button The Checkout options are sent as form-data to the following URL in a POST request.POST: https://api.razorpay.com/v1/checkout/embedded
The sample code is given below:
Hosted Checkout
- For every successful payment,
razorpay_payment_id,razorpay_order_idandrazorpay_signatureare submitted via a POST request to thecallback_urlpassed in payment options. - If your customer cancels the transaction or clicks the back button, they are redirected to the
cancel_urlvia a GET request. - If the payment fails, a POST request is made to the
callback_url, with the error fields as payload.
1.2.2 Checkout Options
key_id mandatory
: string Enter [YOUR_Key_ID] generated from the Dashboard.
name mandatory
: string The business name to be shown in the checkout form.
descriptionoptional
: string Description of the item purchased shown in the checkout form.
image optional
: string URL of the logo that must appear on the checkout form.
order_id mandatory
: string Unique identifier of the Order, created using the Orders API.
amount mandatory
: integer Payment amount in the smallest currency sub-unit. For example, if the amount to be charged is 299, then pass 29900 in this field. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).
method optional
: string Use this parameter to display a specific payment method in Checkout. Possible values:cardnetbankingwalletupipaylater
prefill
: The fields that can be pre-populated in the Checkout form.name optional
: string Name of the cardholder.email mandatory
: string Email address of the customer.contact mandatory
: string Customer’s phone number.notesoptional
: object An additional set of fields that you want to associate with the payment. For example, you can add “shipping address” and “alternate contact” in the Notes field. You can specify up to 15 note fields.Shipping address
: string 106, Razorpay, BangaloreAlternate contact
: string 9000090000callback_url mandatory
: string Page to which the customers are redirected to after a successful payment. razorpay_payment_id, razorpay_order_id and razorpay_signature are sent as form-data through a POST request to the callback_url.Handy TipsCallback URL is not required if you are using the native SDK for Android/iOS.
cancel_urloptional
: string The URL customers are redirected to after the cancellation of a payment.1.3 Store Fields in Your Server
A successful payment returns the following fields to the Checkout form. Success Callback- You need to store these fields in your server.
- You can confirm the authenticity of these details by verifying the signature in the next step.
Success Callback
razorpay_payment_id
: string Unique identifier for the payment returned by Checkout only for successful payments.
razorpay_order_id
: string Unique identifier for the order returned by Checkout.
razorpay_signature
: string Signature returned by the Checkout. This is used to verify the payment.
1.4 Verify Payment Signature
This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments. To verify therazorpay_signature returned to you by the Checkout form:
-
Create a signature in your server using the following attributes:
order_id: Retrieve theorder_idfrom your server. Do not use therazorpay_order_idreturned by Checkout.razorpay_payment_id: Returned by Checkout.key_secret: Available in your server. Thekey_secretthat was generated from the Dashboard.
-
Use the SHA256 algorithm, the
razorpay_payment_idand theorder_idto construct a HMAC hex digest as shown below:HMAC Hex Digest -
If the signature you generate on your server matches the
razorpay_signaturereturned to you by the Checkout form, the payment received is from an authentic source.
Generate Signature on Your Server
Given below is the sample code for payment signature verification:Java
Post Signature Verification
After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs. Here are the links to our SDKs for the supported platforms.1.5 Verify Payment Status
Handy TipsOn the Razorpay Dashboard, ensure that the payment status is
captured. Refer to the payment capture settings page to know how to capture payments automatically.You can track the payment status in three ways:To verify the payment status from the Razorpay Dashboard:- Log in to the Razorpay Dashboard and navigate to Transactions → Payments.
- Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
Example
If you have subscribed to theorder.paid webhook event, you will receive a notification every time a customer pays you for an order.Poll Payment APIs to check the payment status.2. Test Integration
After the integration is complete, a Pay button appears on your webpage/app. Click the button and make a test transaction to ensure the integration is working as expected. You can start accepting actual payments from your customers once the test transaction is successful. You can make test payments using one of the payment methods configured at the Checkout.Supported Payment Methods
Following are all the payment modes that the customer can use to complete the payment on the Checkout. Some of them are available by default, while others require approval from us. Raise a request from the Dashboard to enable such payment methods.Payment Method | Code | Availability
Debit Card | debit | ✓
Credit Card | credit | ✓
Netbanking | netbanking| ✓
UPI | upi | ✓
Wallet | wallet | ✓
Pay Later| paylater | Requires Approval.
Netbanking
You can select any of the listed banks. After choosing a bank, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the bank login portals.
Check the list of supported banks.
UPI
You can enter one of the following UPI IDs:success@razorpay: To make the payment successful.failure@razorpay: To fail the payment.
Handy TipsYou can use Test Mode to test UPI payments, and Live Mode for UPI Intent and QR payments.
Cards
You can use the following test cards to test transactions for your integration in Test Mode.Domestic Cards
Use the following test cards for Indian payments:Network | Card Number | CVV & Expiry Date
Visa | 4100 2800 0000 1007 | Use a random CVV and any future date ^^^^^
Mastercard | 5500 6700 0000 1002 |
RuPay | 6527 6589 0000 1005 |
Diners | 3608 280009 1007 |
Amex | 3402 560004 01007 | Check the following lists:International Cards
Use the following test cards to test international payments. Use any valid expiration date in the future in the MM/YY format and any random CVV to create a successful payment.Card Network | Card Number | CVV & Expiry Date
Mastercard | 5555 5555 5555 4444 5105 1051 0510 5100 5104 0600 0000 0008 | Use a random CVV and any future date ^^
Visa | 4012 8888 8888 1881 |Wallet
You can select any of the listed wallets. After choosing a wallet, Razorpay will redirect to a mock page where you can make the paymentsuccess or a failure. Since this is Test Mode, we will not redirect you to the wallet login portals.
Check the list of supported wallets.
3. Go-live Checklist
Check the go-live checklist for Razorpay Hosted Checkout integration. Consider these steps before taking the integration live.3.1 Accept Live Payments
Perform an end-to-end simulation of funds flow in the Test Mode. Once confident that the integration is working as expected, switch to the Live Mode and start accepting payments from customers.3.2 Payment Capture
After payment isauthorized, you need to capture it to settle the amount to your bank account as per the settlement schedule. Payments that are not captured are auto-refunded after a fixed time.